package bip.gwm.scm.settlement.test;

import bip.gwm.scm.settlement.test.Asymmetric;
import bip.gwm.scm.settlement.test.DecryptDemoV1;
import bip.gwm.scm.settlement.test.EncryptDemoV1;
import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.base.Throwables;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import okhttp3.MediaType;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import okhttp3.Request.Builder;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestDemo {

   private static final Logger log = LoggerFactory.getLogger(TestDemo.class);
   private static ObjectMapper mapper = new ObjectMapper();


   public static String write2JsonString(Object obj) {
      String result = null;
      if(obj != null) {
         try {
            result = mapper.writeValueAsString(obj);
         } catch (JsonProcessingException var3) {
            var3.printStackTrace();
         }
      }

      return result;
   }

   public static Object readJson2Entity(String jsonString, Class clazz) {
      Object result = null;

      try {
         result = mapper.readValue(jsonString, clazz);
      } catch (IOException var4) {
         ;
      }

      return result;
   }

   public static String encryptAndRequset() {
      String appid = "xxx";
      String appsecret = "xxx";
      String publicKey = "xxx";
      String privateKey = "xxx";
      String url = "xxx";
      String bankPublicKey = "xxx";
      String result = "ok";

      try {
         String e = "SM3withSM2";
         String timestamp = String.valueOf((new Date()).getTime() / 1000L);
         HashMap map = new HashMap();
         map.put("id", "123");
         map.put("name", "victor");
         String params = EncryptDemoV1.cmbEncrypt(write2JsonString(map), bankPublicKey);
         String sign = Asymmetric.sm3Signature2(params);
         System.out.println("request(业务参数明文):" + write2JsonString(map));
         System.out.println("request(业务参数密文):" + params);
         ArrayList list = new ArrayList();
         list.add("appid=" + appid);
         list.add("secret=" + appsecret);
         list.add("sign=" + sign);
         list.add("timestamp=" + timestamp);
         String src = String.join("&", list);
         String apisign = Asymmetric.sm3withsm2Signature2(privateKey, src);
         System.out.println("签名前数据:" + src);
         System.out.println("签名后数据:" + apisign);
         RequestBody requestBody = RequestBody.create(MediaType.parse("application/json"), params);
         Request request = (new Builder()).url(url).header("timestamp", timestamp).header("apisign", apisign).header("verify", e).header("appid", appid).header("sign", sign).post(requestBody).build();
         Response response = Asymmetric.getClient().newCall(request).execute();
         Throwable var18 = null;

         try {
            String resBodyString = response.body().string();
            result = resBodyString;
            System.out.println("response(密文):" + resBodyString);
            Map map2 = (Map)readJson2Entity(resBodyString, Map.class);
            String zCipTxt = (String)map2.getOrDefault("zCipTxt", "");
            String zDigEvp = (String)map2.getOrDefault("zDigEvp", "");
            if(StringUtils.isNotBlank(zCipTxt)) {
               result = DecryptDemoV1.CmbEncDecy(privateKey, zCipTxt, zDigEvp);
            }
         } catch (Throwable var31) {
            var18 = var31;
            throw var31;
         } finally {
            if(response != null) {
               if(var18 != null) {
                  try {
                     response.close();
                  } catch (Throwable var30) {
                     var18.addSuppressed(var30);
                  }
               } else {
                  response.close();
               }
            }

         }
      } catch (Exception var33) {
         result = Throwables.getStackTraceAsString(var33);
         log.error("ConsumerTestService.encryptAndRequset error:{}", result);
      }

      System.out.println("response(明文):" + result);
      return result;
   }

   public static void main(String[] args) throws Exception {
      encryptAndRequset();
   }

   static {
      mapper.setSerializationInclusion(Include.NON_NULL);
   }
}
